from os.path import exists
from urllib import urlopen
from utils import last_date_delta


### Find last information about staging updates.

def find_last_staging_update_entries(filename="successful-updates.txt"):
    last_code_update = ""
    last_db_update = ""

    if not exists(filename):
        staging_update_entries = urlopen(
            "https://staging.launchpad.net/successful-updates.txt").readlines()
    else:
        staging_update_entries = open(filename).readlines()

    staging_update_entries.reverse()
    for i in staging_update_entries:
        if "Code update" in i:
            if last_code_update == "":
                last_code_update = i.strip()
        if "Full update" in i:
            last_db_update = i.strip()
            if last_code_update == "":
                last_code_update = i.strip()
            break

    # Parse the entry
    line = last_code_update.split(" ")
    # 0: date
    # 1: time (UTC?)
    # n-1: revno
    last_code_update_info = {'date' : line[0].replace(":", "-"),
             'time' : line[1],
             'revno': line[-1],
    }
    # Parse the entry
    line = last_db_update.split(" ")
    last_db_update_info = {'date' : line[0].replace(":", "-"),
             'time' : line[1],
             'revno': line[-1],
    }

    return last_code_update_info, last_db_update_info


def current_staging_revno(last_code_update_revno, last_db_update_revno):
    if last_code_update_revno > last_db_update_revno:
        return last_code_update_revno
    return last_db_update_revno


last_code_update, last_db_update = find_last_staging_update_entries()

staging_update_info = {'last_code_update' : "",
    'last_db_update'                      : "",
    'revno'                 : "",
    }

staging_update_info['last_code_update'] = (
    "Last staging successful code update was on %s (%s), to revno %s." % (
        last_code_update["date"], last_date_delta(last_code_update["date"]),
        last_code_update["revno"]))

staging_update_info['last_db_update'] += (
    "Last staging DB full update was on %s (%s), to revno %s.\n" % (
        last_db_update["date"], last_date_delta(last_db_update["date"]),
        last_db_update["revno"]))

staging_update_info['revno'] += (
    "Current revno on staging: %s\n" % current_staging_revno(
        last_code_update["revno"], last_db_update["revno"]))



