"""Tests for the devops.deploymentreports module."""

__metaclass__ = type

import unittest

from devops.deploymentreports import DeploymentReport, ReportFilesNotFound
from os.path import dirname, join


class TestDeploymentReport(unittest.TestCase):

    def test_creating_report_folder_exist(self):
        reports_folder = join(dirname(__file__), "sample_data")
        report_name = "deployment-test.html"
        report = DeploymentReport(reports_folder, report_name)
        self.assertEqual(report.fetch_contents(), None)

    def test_creating_report_report_doesnt_exist(self):
        reports_folder = "foobar"
        report_name = "deployment-test.html"
        self.assertRaises(ReportFilesNotFound, DeploymentReport,
            reports_folder, report_name)


class TestGetDeploymentQAData():

    def setUp(self):
        reports_folder = join(dirname(__file__), "sample_data")
        report_name = "deployment-test.html"
        self.report = DeploymentReport(reports_folder, report_name)

