from datetime import datetime, timedelta
from ConfigParser import ConfigParser
from os.path import join, dirname

__metaclass__ = type


class Config:

    def __init__(self, config_file_path):
        self.config_file_path = config_file_path
        self.deployment_reports_path = None
        self.devops_index_path = None
        self.lplib_credentials_file = None

    def read_config_file(self):
        config_parser = ConfigParser()
        config_parser.read([self.config_file_path])

        self.deployment_reports_path = config_parser.get("reports",
            "deployment_reports_path")
        self.devops_index_path = config_parser.get("reports",
            "generated_report_path")
        self.lplib_credentials_file = config_parser.get("credentials",
            "lplib_credentials_file")


def days_ago(date):
    today = datetime.today().toordinal()
    if type(date) is str:
        date_ = datetime.strptime(date, "%Y-%m-%d").toordinal()
    else:
        date_ = date.toordinal()
    return today - date_


def last_date_delta(date):
    days_ago_ = days_ago(date)
    if days_ago_ == 0:
        return "today"
    if days_ago_ == 1:
        return "1 day ago"
    return "%s days ago" % days_ago_


def yesterday():
    return (datetime.today() - timedelta(days=1)).strftime("%Y-%m-%d")


